/*
Scrivere un programma che legga da tastiera una sequenza di n interi distinti
e li inserisca in una lista mono-direzionale (nell'ordine dato). Il programma
entra poi in un ciclo infinito nel quale legge un intero i da tastiera e lo cerca
nella lista. Se i si trova nella lista stampa la sua posizione (contando da
0) e porta l'elemento in testa alla lista (MTF, Move To Front), altrimenti
stampa NO. L'input è formattato nel seguente modo: nella prima riga si
trova la lunghezza della sequenza e nelle successive si trovano gli interi che
compongono la sequenza. Gli interi sono tutti distinti.
*/
#include <stdio.h>
#include <stdlib.h>

typedef struct _Nodo{
	int key;
	struct _Nodo* next;
} Nodo;
typedef Nodo* Lista;


int main() {

	int n;
	Lista l;
	
	//leggo da input la dimensione della lista
	scanf("%d", &n);
	if (n < 1) exit(1); // se la lista non ha elementi esco con errore
	
	//alloco il primo nodo
	l = (Lista) malloc(sizeof(Nodo));
	scanf("%d", &(l->key));
	
	//alloco i nodi successivi 
	//mantenendo un puntatore all'ultimo nodo della lista
	Nodo* ultimo = l;
	int i;
	for (i=1; i<n; i++){
		ultimo->next = (Nodo*) malloc(sizeof(Nodo));
		scanf("%d", &(ultimo->next->key));
		ultimo = ultimo->next;
	}
	ultimo->next = NULL;
	
	while(1){ //ciclo infinito
		//leggo da input la chiave da cercare nella lista
		int k;
		scanf("%d", &k);
		
		//scorro la lista e mantengo un puntatore al nodo precedente
		Nodo* precedente = NULL;
		Nodo* corrente = l;
		int pos=0;
		while(corrente != NULL && corrente->key != k){
			precedente = corrente;
			corrente = corrente->next;
			pos++;
		}
	
		if (corrente == NULL){ // ho raggiunto la fine della lista e non ho trovato k
			printf("NO\n");
		} else {
			//stampo la posizione di k nella lista
			printf("%d\n", pos);
			if (precedente != NULL){ 
				//se il precedente è NULL, k si trova già in prima posizione
				//altrimenti sposto l'elemento con chiave=k in testa
				precedente->next = corrente->next;
				corrente->next = l;
				l = corrente;
			}
		}
		
	}
	return 0;
}
