/*
Scrivere un programma che legga da input una sequenza di punti a coor-
dinate intere, dove per ciascun punto l'utente immette le due coordinate.
Quindi il programma stampa la sequenza di punti ordinata per valori cres-
centi dell'ascissa. L'input è formattato nel solito modo: il primo numero che
l'utente inserisce è N e identifica la lunghezza della lista di punti. Seguono
poi 2N interi in input che rappresentano le coordinate di N punti.
Suggerimento: utilizzare la libreria qsort per l'ordinamento dei punti.
*/
#include <stdio.h>
#include <stdlib.h>

typedef struct _Punto{
	int x, y;
} Punto;


int comparatore(const void *p1, const void *p2){
	//effettuo il cast (conversione) per poter operare su i dati che sto confrontando
	Punto *a = * (Punto**)p1;
	Punto *b = * (Punto**)p2;
	
	//con in puntatori ad un struct posso usare la notazione -> per accedere ai relativi campi
	return a->x - b->x;
}


int main() {

	int n;
	Punto **A;
	
	//leggo da input la dimensione dell'array di punti
	scanf("%d", &n);
	
	//alloco l'array di punti
	A = (Punto**) malloc(n*sizeof(Punto*));
	
	//riempo A
	int i;
	for (i=0; i<n; i++){
		A[i] = (Punto*) malloc(sizeof(Punto));
		scanf("%d", &(A[i]->x));
		scanf("%d", &(A[i]->y));
	}

	//eseguo l'ordinamento
	qsort(A, n, sizeof(Punto*), comparatore);

	//stampo l'array di punti
	printf("\n");
	for(i=0; i<n; i++)
		printf("(%d;%d)\n", A[i]->x, A[i]->y);
	return 0;
}
